//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 14.5 on page 279
//  Mapping keys into a hash table of size 101

import java.util.*;

public class Ex1405
{ private static final int MASK = 0x7FFFFFFF; // 2^32-1
  private static final int CAPACITY = 101;
  
  public static void main(String[] args)
  { printHash("Rad");
    printHash("Uhr");
    printHash("Ohr");
    printHash("Tor");
    printHash("Hut");
    printHash("Tag");
  }
  
  private static void printHash(String word)
  { System.out.println("hash(" + word + ") = " + hash(word));
  }
  
  private static int hash(Object object)
  { return (object.hashCode() & MASK) % CAPACITY;
  }
}
