//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 14.6 on page 280
//  Using linear probing in a hash table

import java.util.*;

public class Ex1406
{ private static final int MASK = 0x7FFFFFFF; // 2^32-1
  private static final int CAPACITY = 11;
  private static int size=0;
  private static boolean[] used = new boolean[CAPACITY];
  
  public static void main(String[] args)
  { printHash("Rad");
    printHash("Uhr");
    printHash("Ohr");
    printHash("Tor");
    printHash("Hut");
    printHash("Tag");
    printHash("Eis");
    printHash("Ast");
    printHash("Zug");
    printHash("Hof");
    printHash("Mal");
  }
  
  private static void printHash(String word)
  { System.out.println("hash(" + word + ") = " + hash(word)
            + ", load = " + 100*size/CAPACITY + "%");
  }
  
  private static int hash(Object object)
  { ++size;
    int h = (object.hashCode() & MASK) % CAPACITY;
    while (used[h])
    { System.out.print(h + ", ");
      h = (h+1)%CAPACITY;
    }
    used[h] = true;
    return h;
  }
}
