//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 14.7 on page 282
//  Using quadratic probing in a hash table

import java.util.*;

public class Ex1407
{ private static final int MASK = 0x7FFFFFFF; // 2^32-1
  private static final int CAPACITY = 11;
  private static int size=0;
  private static boolean[] used = new boolean[CAPACITY];
  
  public static void main(String[] args)
  { printHash("Rad");
    printHash("Uhr");
    printHash("Ohr");
    printHash("Tor");
    printHash("Hut");
    printHash("Tag");
    printHash("Eis");
    printHash("Ast");
    printHash("Zug");
  }
  
  private static void printHash(String word)
  { System.out.println("hash(" + word + ") = " + hash(word)
            + ", load = " + 100*size/CAPACITY + "%");
  }
  
  private static int hash(Object object)
  { ++size;
    int h = (object.hashCode() & MASK) % CAPACITY;
    if (used[h])
    { int h0=h;
      int jump=1;
      while (used[h])
      { System.out.print(h + ", ");
        h = (h0+jump*jump)%CAPACITY;
        ++jump;
      }
    }
    used[h] = true;
    return h;
  }
}
