//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 14.10 on page 286
//  An ordered concordance

import java.io.*;
import java.util.*;

public class Ex1410
{ private static Map concordance;
  private static File file;
  private static FileReader reader;
  private static BufferedReader in;
      
  public static void main(String[] args)
  { new Ex1410("Shakespeare.txt");
    load();
    dump();
  }
  
  Ex1410(String filename)
  { try
    { concordance = new TreeMap();
      file = new File(filename);
      reader = new FileReader(file);
      in = new BufferedReader(reader);
    }
    catch(Exception e) { System.out.println(e); }
  }
  
  private static void load()
  { String line=null;
    StringTokenizer parser=null;
    int lineNumber=0;
    try
    { while ((line=in.readLine()) != null)
      { ++lineNumber;
        parser = new StringTokenizer(line,",.;:()-!?' ");
        while (parser.hasMoreTokens())
        { String word = parser.nextToken().toUpperCase();
          String listing = (String)concordance.get(word);
          if (listing==null) listing = "" + lineNumber;
          else listing += ", " + lineNumber;
          concordance.put(word,listing);
        }
      }
    }
    catch(Exception e) { System.out.println(e); }
  }

  private static void dump()
  { Set set = concordance.entrySet();
    for (Iterator it=set.iterator(); it.hasNext(); )
      System.out.println(it.next());
  }
}
