//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Problem 14.4 on page 292
//  A frequency table of words

import java.io.*;
import java.util.*;

public class Pr1404
{ private static Map concordance;
  private static File file;
  private static FileReader reader;
  private static BufferedReader in;
      
  public static void main(String[] args)
  { loadMap("Shakespeare.txt");
    dumpMap();
  }
  
  private static void loadMap(String filename)
  { try
    { concordance = new TreeMap();
      file = new File(filename);
      reader = new FileReader(file);
      in = new BufferedReader(reader);
      String line=null;
      StringTokenizer parser=null;
      int lineNumber=0;
      while ((line=in.readLine()) != null)
      { ++lineNumber;
        parser = new StringTokenizer(line,",.;:()-!?' ");
        while (parser.hasMoreTokens())
        { String word = parser.nextToken().toUpperCase();
          String frequency = (String)concordance.get(word);
          if (frequency==null) frequency = "1";
          else
          { int n=Integer.parseInt(frequency);
            ++n;
            frequency = "" + n;
          }
          concordance.put(word,frequency);
        }
      }
    }
    catch(Exception e) { System.out.println(e); }
  }

  private static void dumpMap()
  { Set set = concordance.entrySet();
    for (Iterator it=set.iterator(); it.hasNext(); )
      System.out.println(it.next());
  }
}
